#ifndef Bees_Algorithm_h
#define Bees_Algorithm_h

#include "../../ECF/Algorithm.h"
#include "../../ECF/floatingpoint/FloatingPoint.h"
#include <vector>

class BeesAlgorithm : public Algorithm{
protected:
	SelWorstOpP selWorstOp_;
	
	uint scouts_;
	uint foragers_;
	uint popSize_; //population of the generation is the group of the best scout bees!
	float local_;
	uint dimension_;
	double ubound_;
	double lbound_;
	vector<double> searchSize_;

	void foragingPhase(StateP state, DemeP deme);
	void scoutingPhase(StateP state, DemeP deme);
	IndividualP createForager(StateP state, IndividualP ref, double searchSize);
	IndividualP createScout(StateP state);
	uint findWorstBee(StateP state, DemeP deme);
	//TODO

public:
	BeesAlgorithm();
	void registerParameters(StateP state);
	bool initialize(StateP state);
	bool advanceGeneration(StateP state, DemeP deme);
};

typedef boost::shared_ptr<BeesAlgorithm> BeesAlgorithmP;

#endif
